using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;

namespace GDBG_RowsAdded
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.CheckBox checkBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.button1 = new System.Windows.Forms.Button();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(32, 40);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(408, 264);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(472, 24);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(75, 48);
			this.button1.TabIndex = 1;
			this.button1.Text = "Add Rows";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(136, 8);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(168, 24);
			this.checkBox1.TabIndex = 2;
			this.checkBox1.Text = "Hide PrimaryKey column";
			this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(560, 318);
			this.Controls.Add(this.checkBox1);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		DataTable dt;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			dt = GetTable();
			this.gridDataBoundGrid1.DataSource = this.dt;

			this.gridDataBoundGrid1.Model.RowsInserted += new GridRangeInsertedEventHandler(Model_RowsInserted);
			this.dt.RowChanging +=new DataRowChangeEventHandler(dt_RowChanging);

			// ArrayList to hold selected row's PrimaryKeys..
			list1 = new ArrayList();
			this.dt.DefaultView.Sort = "Col1 ASC";

			//Select some rows
			this.gridDataBoundGrid1.Selections.SelectRange(GridRangeInfo.Rows(2,4), true);
			this.gridDataBoundGrid1.Selections.SelectRange(GridRangeInfo.Row(7), true);

			
		}

		private DataTable GetTable()
		{
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 10;

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));
			dt.PrimaryKey = new DataColumn[]{dt.Columns["Col0"]}; //make Col1 a primary key so we can find rows
			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i+1;
				for(int j = 1; j < nCols; j++)
					dr[j] = string.Format("row{0} col{1}", i, j);
				dt.Rows.Add(dr);
			}
			return dt;
		}


		int i = 11;

		private void button1_Click(object sender, System.EventArgs e)
		{
			// Insert a random row
			DataRow dr = dt.NewRow();
			if((i%2) == 0)
			{
				dr[1] = "ABCD";
			}
			else
			{
				dr[1] = "ZXY";
			}
			dr[0] = i++;
			this.dt.Rows.InsertAt(dr, 3); 

			this.dt.AcceptChanges();
		}

		private void Model_RowsInserted(object sender, GridRangeInsertedEventArgs e)
		{
			this.gridDataBoundGrid1.BeginUpdate();

			// After rows have been added
			this.gridDataBoundGrid1.Selections.Clear();

			for(int k = 1; k < this.gridDataBoundGrid1.Model.RowCount; k++)
			{
				IEnumerator IE = list1.GetEnumerator();
				for(int j = 0; j < list1.Count; ++j)
				{
					IE.MoveNext();
					if(int.Parse(IE.Current.ToString()) == int.Parse(this.gridDataBoundGrid1[k, 1].CellValue.ToString()))
					{
						this.gridDataBoundGrid1.Selections.Add(GridRangeInfo.Row(k));
					}
				}
			}

			this.gridDataBoundGrid1.EndUpdate();
		}

		ArrayList list1;

		private void dt_RowChanging(object sender, DataRowChangeEventArgs e)
		{
			if(e.Action == DataRowAction.Add)
			{
				// Before rows have been added
				System.Diagnostics.Trace.WriteLine("Before rows have been added" + this.gridDataBoundGrid1.Selections.GetSelectedRows(true, true));
				CurrencyManager cm = (CurrencyManager) this.BindingContext[this.gridDataBoundGrid1.DataSource, this.gridDataBoundGrid1.DataMember];
			
				GridRangeInfoList list;
				list = this.gridDataBoundGrid1.Selections.GetSelectedRows(true, false);

				foreach(GridRangeInfo range in list)
				{
					for(int i = range.Top; i <= range.Bottom; i++)
					{
						Console.WriteLine(((DataView)cm.List)[this.gridDataBoundGrid1.Binder.RowIndexToPosition(i)]["Col0"]);
						int pKey = int.Parse(((DataView)cm.List)[this.gridDataBoundGrid1.Binder.RowIndexToPosition(i)]["Col0"].ToString());
						list1.Add(pKey);
					}
				}
			}
		}

		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{
			this.gridDataBoundGrid1.Model.Cols.Hidden[1] = this.checkBox1.Checked;		
		}
	}
}
